/* This is a file evolved from Folding MicroEmacs 3.10.21a */
/* built by Mike Burrow and Andy Sturgess at Inmos.        */
/* Folding MicroEmacs has ben tested on Sun and PC only.   */
/* Itself based on MicroEmacs 3.10 by Daniel M Kawrence    */
/* and Dave G Conroy.                                      */

/* SccsID[] = "@(#)edef.h	1.4 95/08/11"; */                            
/*	EDEF:		Global variable definitions for
			MicroEMACS 3.9

                        written by Daniel Lawrence
                        based on code by Dave G. Conroy,
                        	Steve Wilhite and George Jones
*/

/*	Modifications:
	13-Sep-89	Mike Burrow (INMOS)	Added folding.
*/

#ifdef	maindef

/* for MAIN.C */

/* initialized global definitions */

NOSHARE int DNEAR fillcol = 72; 	/* Current fill column		*/
NOSHARE short kbdm[NKBDM];		/* Macro			*/
NOSHARE char *execstr = NULL;		/* pointer to string to execute */
NOSHARE char golabel[NPAT] = "";	/* current line to go to	*/
NOSHARE int DNEAR execlevel = 0;	/* execution IF level		*/
NOSHARE int DNEAR eolexist = TRUE;	/* does clear to EOL exist?	*/
NOSHARE int DNEAR revexist = FALSE;	/* does reverse video exist?	*/
NOSHARE int DNEAR flickcode = TRUE;	/* do flicker supression?	*/
CONST char *modename[] = { 		/* name of modes		*/
	"WRAP", "CMODE", "SPELL", "EXACT", "VIEW", "OVER",
	"MAGIC", "CRYPT", "ASAVE"};
CONST char modecode[] = "WCSEVOMYA";	/* letters to represent modes	*/
NOSHARE int DNEAR numfunc = NFUNCS;	/* number of bindable functions */
NOSHARE int DNEAR gmode = 0;		/* global editor mode		*/
NOSHARE int DNEAR gflags = GFREAD;	/* global control flag		*/
NOSHARE int DNEAR gfcolor = 7;		/* global forgrnd color (white) */
NOSHARE int DNEAR gbcolor = 0;		/* global backgrnd color (black)*/
NOSHARE int DNEAR gasave = 256; 	/* global ASAVE size		*/
NOSHARE int DNEAR gacount = 256;	/* count until next ASAVE	*/
NOSHARE int DNEAR sgarbf = TRUE; 	/* TRUE if screen is garbage	*/
NOSHARE int DNEAR mpresf = FALSE;	/* TRUE if message in last line */
NOSHARE int DNEAR clexec = FALSE;	/* command line execution flag	*/
NOSHARE int DNEAR mstore = FALSE;	/* storing text to macro flag	*/
NOSHARE int DNEAR discmd = TRUE; 	/* display command flag 	*/
NOSHARE int DNEAR disinp = TRUE; 	/* display input characters	*/
NOSHARE int DNEAR modeflag = TRUE;	/* display modelines flag	*/
NOSHARE int DNEAR sscroll = FALSE;	/* smooth scrolling enabled flag*/
NOSHARE int DNEAR hscroll = TRUE;	/* horizontal scrolling flag	*/
NOSHARE int DNEAR hjump = 1;		/* horizontal jump size 	*/
NOSHARE int DNEAR ssave = FALSE; 	/* safe save flag		*/
NOSHARE struct BUFFER *bstore = NULL;	/* buffer to store macro text to*/
NOSHARE int DNEAR vtrow = 0;		/* Row location of SW cursor	*/
NOSHARE int DNEAR vtcol = 0;		/* Column location of SW cursor */
NOSHARE int DNEAR ttrow = HUGE; 	/* Row location of HW cursor	*/
NOSHARE int DNEAR ttcol = HUGE; 	/* Column location of HW cursor */
NOSHARE int DNEAR lbound = 0;		/* leftmost column of current line
					   being displayed		*/
NOSHARE int DNEAR taboff = 0;		/* tab offset for display	*/
NOSHARE int DNEAR tabsize = 8;		/* current hard tab size	*/
NOSHARE int DNEAR stabsize = 0;		/* current soft tab size (0: use hard tabs)  */
NOSHARE int DNEAR reptc = C_TRL | 'U';	/* current universal repeat char*/
NOSHARE int DNEAR abortc = C_TRL | 'G';	/* current abort command char	*/
#if KBDTIME
NOSHARE int DNEAR sterm = C_TRL | '[';	/* search terminating character */
#else
NOSHARE int DNEAR sterm = C_TRL | 'M';	/* search terminating character */
#endif
NOSHARE int DNEAR prefix = 0;		/* currently pending prefix bits */
NOSHARE int DNEAR prenum = 0;		/*     "       "     numeric arg */
NOSHARE int DNEAR predef = TRUE;	/*     "       "     default flag */

NOSHARE int DNEAR quotec = 0x11;	/* quote char during mlreply() */
NOSHARE CONST char *cname[] = {		/* names of colors		*/
	"BLACK", "RED", "GREEN", "YELLOW", "BLUE",
	"MAGENTA", "CYAN", "GREY",
	"GRAY", "LRED", "LGREEN", "LYELLOW", "LBLUE",
	"LMAGENTA", "LCYAN", "WHITE"};
NOSHARE KILL *kbufp = NULL;		/* current kill buffer chunk pointer*/
NOSHARE KILL *kbufh = NULL;		/* kill buffer header pointer	*/
NOSHARE int kused = KBLOCK;		/* # of bytes used in kill buffer*/
NOSHARE WINDOW *swindow = NULL; 	/* saved window pointer 	*/
NOSHARE int cryptflag = FALSE;		/* currently encrypting?	*/
NOSHARE int oldcrypt = FALSE;		/* using old(broken) encryption? */
NOSHARE short *kbdptr;			/* current position in keyboard buf */
NOSHARE short *kbdend = &kbdm[0];	/* ptr to end of the keyboard */
NOSHARE int DNEAR kbdmode = STOP;	/* current keyboard macro mode	*/
NOSHARE int DNEAR kbdrep = 0;		/* number of repetitions	*/
NOSHARE int DNEAR restflag = FALSE;	/* restricted use?		*/
NOSHARE int DNEAR lastkey = 0;		/* last keystoke		*/
NOSHARE int DNEAR seed = 0;		/* random number seed		*/
NOSHARE long envram = 0l;		/* # of bytes current in use by malloc */
NOSHARE int DNEAR macbug = FALSE;	/* macro debugging flag		*/
NOSHARE int DNEAR mouseflag = TRUE;	/* use the mouse?		*/
NOSHARE int DNEAR diagflag = FALSE;	/* diagonal mouse movements?	*/
CONST char errorm[] = "ERROR";		/* error literal		*/
CONST char truem[] = "TRUE";		/* true literal 		*/
CONST char falsem[] = "FALSE";		/* false litereal		*/
NOSHARE int DNEAR cmdstatus = TRUE;	/* last command status		*/
NOSHARE char palstr[49] = "";		/* palette string		*/
NOSHARE char lastmesg[NLONGS] = ""; 	/* last message posted		*/
NOSHARE char *lastptr = NULL;		/* ptr to lastmesg[]		*/
NOSHARE int DNEAR saveflag = 0; 	/* Flags, saved with the $target var */
NOSHARE char *fline = NULL;		/* dynamic return line		*/
NOSHARE int DNEAR flen = 0;		/* current length of fline	*/
NOSHARE int DNEAR rval = 0;		/* return value of a subprocess */
NOSHARE int DNEAR eexitflag = FALSE;	/* EMACS exit flag		*/
NOSHARE int DNEAR eexitval = 0; 	/* and the exit return value	*/
NOSHARE int xpos = 0;		/* current column mouse is positioned to*/
NOSHARE int ypos = 0;		/* current screen row	     "		*/
NOSHARE int nclicks = 0;	/* cleared on any non-mouse event	*/

/* uninitialized global definitions */

NOSHARE int DNEAR currow;	/* Cursor row			*/
NOSHARE int DNEAR curcol;	/* Cursor column		*/
NOSHARE int DNEAR thisflag;	/* Flags, this command		*/
NOSHARE int DNEAR lastflag;	/* Flags, last command		*/
NOSHARE int DNEAR curgoal;	/* Goal for C-P, C-N		*/
NOSHARE WINDOW *curwp; 		/* Current window		*/
NOSHARE BUFFER *curbp; 		/* Current buffer		*/
NOSHARE WINDOW *wheadp;		/* Head of list of windows	*/
NOSHARE BUFFER *bheadp;		/* Head of list of buffers 	*/
NOSHARE BUFFER *blistp;		/* Buffer for C-X C-B		*/

NOSHARE char sres[NBUFN];	/* current screen resolution	*/

NOSHARE int killfoldbound;	/* kill buffer boundaries on fold */
NOSHARE int killedcr;		/* kill buffer contains a [NL] */

NOSHARE FOLDLINELIST	*linelist;	/* Fold lines. MJB: 15-Sep-89 */

#if	DIACRIT
NOSHARE	char lowcase[HICHAR];	/* lower casing map		*/
NOSHARE	char upcase[HICHAR];	/* upper casing map		*/
#endif

NOSHARE char pat[NPAT];		/* Search pattern		*/
NOSHARE char tap[NPAT];		/* Reversed pattern array.	*/
NOSHARE char rpat[NPAT];	/* replacement pattern		*/

/*	Various "Hook" execution variables	*/

NOSHARE KEYTAB readhook;	/* executed on all file reads */
NOSHARE KEYTAB wraphook;	/* executed when wrapping text */
NOSHARE KEYTAB cmdhook;		/* executed before looking for a command */
NOSHARE KEYTAB writehook;	/* executed on all file writes */
NOSHARE KEYTAB exbhook;		/* executed when exiting a buffer */
NOSHARE KEYTAB bufhook;		/* executed when entering a buffer */

/*	The variable matchlen holds the length of the matched string -
	used by the replace functions. The variable patmatch holds the
	string that satisfies the search command. The variables matchline
	and matchoff hold the line and offset position of the *start* of
	match.
*/

NOSHARE unsigned int DNEAR matchlen = 0;
NOSHARE unsigned int DNEAR mlenold  = 0;
NOSHARE char *patmatch = NULL;
NOSHARE LINE *matchline = NULL;
NOSHARE int DNEAR matchoff = 0;

#if	MAGIC
/*
 * The variables magical and rmagical determine if there
 * were actual metacharacters in the search and replace strings -
 * if not, then we don't have to use the slower MAGIC mode
 * search functions.
 */
NOSHARE short int DNEAR magical = FALSE;
NOSHARE short int DNEAR rmagical = FALSE;
NOSHARE MC mcpat[NPAT]; 	/* the magic pattern		*/
NOSHARE MC tapcm[NPAT]; 	/* the reversed magic pattern	*/
NOSHARE RMC rmcpat[NPAT];	/* the replacement magic array	*/

NOSHARE char *sec_string[10];

#endif

/* directive name table:
	This holds the names of all the directives....	*/

CONST char *dname[] = {
	"if", "else", "endif",
	"goto", "return", "endm",
	"while", "endwhile", "break",
	"force"
};

#if	DEBUGM
/*	vars needed for macro debugging output	*/
NOSHARE char outline[NSTRING];	/* global string to hold debug line text */
#endif

#else

/* for all the other .C files */

/* initialized global external declarations */

extern NOSHARE int DNEAR fillcol;	/* Current fill column		*/
extern NOSHARE short kbdm[];		/* Holds kayboard macro data	*/
extern NOSHARE char *execstr;		/* pointer to string to execute */
extern NOSHARE char golabel[];		/* current line to go to	*/
extern NOSHARE int DNEAR execlevel;	/* execution IF level		*/
extern NOSHARE int DNEAR eolexist;	/* does clear to EOL exist?	*/
extern NOSHARE int DNEAR revexist;	/* does reverse video exist?	*/
extern NOSHARE int DNEAR flickcode;	/* do flicker supression?	*/
extern CONST char *modename[];		/* text names of modes		*/
extern CONST char modecode[];		/* letters to represent modes	*/
extern NOSHARE int DNEAR numfunc;	/* number of bindable functions */
extern NOSHARE KEYTAB keytab[];		/* key bind to functions table	*/
extern NOSHARE NBIND names[];		/* name to function table	*/
extern NOSHARE int DNEAR gmode;		/* global editor mode		*/
extern NOSHARE int DNEAR gflags;	/* global control flag		*/
extern NOSHARE int DNEAR gfcolor;	/* global forgrnd color (white) */
extern NOSHARE int DNEAR gbcolor;	/* global backgrnd color (black)*/
extern NOSHARE int DNEAR gasave;	/* global ASAVE size		*/
extern NOSHARE int DNEAR gacount;	/* count until next ASAVE	*/
extern NOSHARE int DNEAR sgarbf;	/* State of screen unknown	*/
extern NOSHARE int DNEAR mpresf;	/* Stuff in message line	*/
extern NOSHARE int DNEAR clexec;	/* command line execution flag	*/
extern NOSHARE int DNEAR mstore;	/* storing text to macro flag	*/
extern NOSHARE int DNEAR discmd;	/* display command flag 	*/
extern NOSHARE int DNEAR disinp;	/* display input characters	*/
extern NOSHARE int DNEAR modeflag;	/* display modelines flag	*/
extern NOSHARE int DNEAR sscroll;	/* smooth scrolling enabled flag*/
extern NOSHARE int DNEAR hscroll;	/* horizontal scrolling flag	*/
extern NOSHARE int DNEAR hjump;		/* horizontal jump size 	*/
extern NOSHARE int DNEAR ssave;		/* safe save flag		*/
extern NOSHARE struct BUFFER *bstore;	/* buffer to store macro text to*/
extern NOSHARE int DNEAR vtrow;		/* Row location of SW cursor	*/
extern NOSHARE int DNEAR vtcol;		/* Column location of SW cursor */
extern NOSHARE int DNEAR ttrow;		/* Row location of HW cursor	*/
extern NOSHARE int DNEAR ttcol;		/* Column location of HW cursor */
extern NOSHARE int DNEAR lbound;	/* leftmost column of current line
					   being displayed		*/
extern NOSHARE int DNEAR taboff;	/* tab offset for display	*/
extern NOSHARE int DNEAR tabsize;	/* current hard tab size	*/
extern NOSHARE int DNEAR stabsize;	/* current soft tab size (0: use hard tabs)  */
extern NOSHARE int DNEAR reptc;		/* current universal repeat char*/
extern NOSHARE int DNEAR abortc;	/* current abort command char	*/
extern NOSHARE int DNEAR sterm;		/* search terminating character */

NOSHARE	extern FOLDMARKENT *foldmarktab; /* Fold marker table. BG: 11-Oct-89 */

extern NOSHARE int DNEAR prefix;	/* currently pending prefix bits */
extern NOSHARE int DNEAR prenum;	/*     "       "     numeric arg */
extern NOSHARE int DNEAR predef;	/*     "       "     default flag */

extern NOSHARE int DNEAR quotec;	/* quote char during mlreply() */
extern CONST char *cname[];		/* names of colors		*/
extern NOSHARE KILL *kbufp;		/* current kill buffer chunk pointer */
extern NOSHARE KILL *kbufh;		/* kill buffer header pointer	*/
extern NOSHARE int kused;		/* # of bytes used in kill buffer*/
extern NOSHARE WINDOW *swindow; 	/* saved window pointer 	*/
extern NOSHARE int cryptflag;		/* currently encrypting?	*/
extern NOSHARE int oldcrypt;		/* using old(broken) encryption? */
extern NOSHARE short *kbdptr;		/* current position in keyboard buf */
extern NOSHARE short *kbdend;		/* ptr to end of the keyboard */
extern NOSHARE int kbdmode;		/* current keyboard macro mode	*/
extern NOSHARE int kbdrep;		/* number of repetitions	*/
extern NOSHARE int restflag;		/* restricted use?		*/
extern NOSHARE int lastkey;		/* last keystoke		*/
extern NOSHARE int seed;		/* random number seed		*/
extern NOSHARE long envram;		/* # of bytes current in use by malloc */
extern NOSHARE int DNEAR macbug;	/* macro debugging flag		*/
extern NOSHARE int DNEAR mouseflag;	/* use the mouse?		*/
extern NOSHARE int DNEAR diagflag;	/* diagonal mouse movements?	*/
extern CONST char errorm[];		/* error literal		*/
extern CONST char truem[];		/* true literal 		*/
extern CONST char falsem[];		/* false litereal		*/
extern NOSHARE int DNEAR cmdstatus;	/* last command status		*/
extern NOSHARE char palstr[];		/* palette string		*/
extern NOSHARE char lastmesg[];		/* last message posted		*/
extern NOSHARE char *lastptr;		/* ptr to lastmesg[]		*/
extern NOSHARE int DNEAR saveflag;	/* Flags, saved with the $target var */
extern NOSHARE char *fline; 		/* dynamic return line */
extern NOSHARE int DNEAR flen; 		/* current length of fline */
extern NOSHARE int DNEAR rval; 		/* return value of a subprocess */
extern NOSHARE int DNEAR eexitflag;	/* EMACS exit flag */
extern NOSHARE int DNEAR eexitval;	/* and the exit return value */
extern NOSHARE int xpos;		/* current column mouse is positioned to */
extern NOSHARE int ypos;		/* current screen row	     "	 */
extern NOSHARE int nclicks;		/* cleared on any non-mouse event*/

/* uninitialized global external declarations */

extern NOSHARE int DNEAR currow;	/* Cursor row			*/
extern NOSHARE int DNEAR curcol;	/* Cursor column		*/
extern NOSHARE int DNEAR thisflag;	/* Flags, this command		*/
extern NOSHARE int DNEAR lastflag;	/* Flags, last command		*/
extern NOSHARE int DNEAR curgoal;	/* Goal for C-P, C-N		*/
extern NOSHARE WINDOW *curwp; 		/* Current window		*/
extern NOSHARE BUFFER *curbp; 		/* Current buffer		*/
extern NOSHARE WINDOW *wheadp;		/* Head of list of windows	*/
extern NOSHARE BUFFER *bheadp;		/* Head of list of buffers	*/
extern NOSHARE BUFFER *blistp;		/* Buffer for C-X C-B		*/

extern NOSHARE char sres[NBUFN];	/* current screen resolution	*/

extern NOSHARE int killfoldbound;	/* kill buffer is fold bounded */
extern NOSHARE int killedcr;		/* kill buffer contains a [NL] */

extern NOSHARE FOLDLINELIST *linelist;	/* Fold lines. MJB: 15-Sep-89 */

#if	DIACRIT
NOSHARE	extern char lowcase[HICHAR];	/* lower casing map		*/
NOSHARE	extern char upcase[HICHAR];	/* upper casing map		*/
#endif

extern NOSHARE char pat[];		/* Search pattern		*/
extern NOSHARE char tap[];		/* Reversed pattern array.	*/
extern NOSHARE char rpat[]; 		/* replacement pattern		*/

/*	Various "Hook" execution variables	*/

extern NOSHARE KEYTAB readhook;		/* executed on all file reads */
extern NOSHARE KEYTAB wraphook;		/* executed when wrapping text */
extern NOSHARE KEYTAB cmdhook;		/* executed before looking for a cmd */
extern NOSHARE KEYTAB writehook;	/* executed on all file writes */
extern NOSHARE KEYTAB exbhook;		/* executed when exiting a buffer */
extern NOSHARE KEYTAB bufhook;		/* executed when entering a buffer */

extern NOSHARE unsigned int matchlen;
extern NOSHARE unsigned int mlenold;
extern NOSHARE char *patmatch;
extern NOSHARE LINE *matchline;
extern NOSHARE int matchoff;

#if	MAGIC
extern NOSHARE short int magical;
extern NOSHARE short int rmagical;
extern NOSHARE MC mcpat[NPAT];		/* the magic pattern		*/
extern NOSHARE MC tapcm[NPAT];		/* the reversed magic pattern	*/
extern NOSHARE RMC rmcpat[NPAT];	/* the replacement magic array	*/
extern NOSHARE char *sec_string[10];
#endif

extern CONST char *dname[];		/* directive name table 	*/

#if	DEBUGM
/*	vars needed for macro debugging output	*/
extern NOSHARE char outline[];	/* global string to hold debug line text */
#endif

#endif

/* terminal table defined only in TERM.C */

#ifndef term_def
extern NOSHARE TERM	term;	/* Terminal information.	*/
#endif
