/* This is a file evolved from Folding MicroEmacs 3.10.21a */
/* built by Mike Burrow and Andy Sturgess at Inmos.        */
/* Folding MicroEmacs has ben tested on Sun and PC only.   */
/* Itself based on MicroEmacs 3.10 by Daniel M Kawrence    */
/* and Dave G Conroy.                                      */

/* SccsID[] = "@(#)etype.h	1.4\t5/16/95"; */                            
/*	ETYPE:		Global function type definitions for
			MicroEMACS 3.9

                        written by Daniel Lawrence
                        based on code by Dave G. Conroy,
                        	Steve Wilhite and George Jones
*/

/*	Modifications:
	11-Sep-89	Mike Burrow (INMOS)	Added folding.
*/


/* ALL global fuction declarations */

#if AIX | SUNOS
#include <stdlib.h>
#include <string.h>
#endif
#define INT int

BUFFER *PASCAL NEAR bfind( char *bname, int cflag, int bflag);
BUFFER *PASCAL NEAR getdefb(void);
BUFFER *PASCAL NEAR getcbuf(char *prompt, char *defval, int createflag);
char *PASCAL NEAR bytecopy(char *dst, char *src, int maxlen);
char *PASCAL NEAR complete(char *prompt, char *defval, int type, int maxlen);
char *PASCAL NEAR envval(int i);
char *PASCAL NEAR fixnull(char *s);
const char *PASCAL NEAR flook(const char *fname, int hflag);
char *PASCAL NEAR funval(int i);
char *PASCAL NEAR getctext(void);
char *PASCAL NEAR getfname(KEYTAB *key);
char *PASCAL NEAR getkill(void);
char *PASCAL NEAR getreg(void);
char *PASCAL NEAR getval(char *token);
char *PASCAL NEAR gtenv(char *vname);
char *PASCAL NEAR gtfilename(char *prompt);
char *PASCAL NEAR gtfun(char *fname);
char *PASCAL NEAR gtusr(char *vname);
char *PASCAL NEAR int_asc(int i);
char *PASCAL NEAR ltos(int val);
char *PASCAL NEAR makename(char *bname, char *fname);
char *PASCAL NEAR mklower(char *str);
char *PASCAL NEAR mkupper(char *str);
char *PASCAL NEAR namval(int index);
char *PASCAL NEAR timeset();
char *PASCAL NEAR token(char *src, char *tok, int size);
char *PASCAL NEAR transbind(char *skey);
char *PASCAL NEAR trimstr(char *s);
char *PASCAL NEAR xlat(char *source, char *lookup, char *trans);
int (PASCAL NEAR *PASCAL NEAR fncmatch(char *fname))();
int (PASCAL NEAR *PASCAL NEAR getname(char *prompt))();
int PASCAL NEAR absv(int x);
int PASCAL NEAR amatch( MC *mcptr,
                       int direct,
                       LINE **pcwline,
                       int *pcwoff);
int PASCAL NEAR biteq(int bc, BITMAP cclmap);
int PASCAL NEAR boundry(LINE *curline, int curoff, int dir);
int PASCAL NEAR cclmake(char **ppatptr, MC *mcptr);
int PASCAL NEAR checknext(int chr, char *patrn, int dir);
int PASCAL NEAR desfunc(int f, int n);
int PASCAL NEAR desvars(int f, int n);
int PASCAL NEAR dispvar(int f, int n);
int PASCAL NEAR echochar(int c, int col);
int PASCAL NEAR eq( int bc,  int pc);
int PASCAL NEAR ernd(void);
int PASCAL NEAR execkey(KEYTAB *key, int f, int n);
int PASCAL NEAR fbound(int jump, LINE **pcurline, int *pcuroff, int dir);
int PASCAL NEAR fexist(char *fname);
int PASCAL NEAR fisearch(int f, int n);
int PASCAL NEAR getkey(void);
int PASCAL NEAR gettyp(char *token);
int PASCAL NEAR getwpos(void);
int PASCAL NEAR get_char(void);
int PASCAL NEAR indx(char *s, char *t);			/* MJB: 20-Sep-89 */
int PASCAL NEAR initlinelist(void);		/* MJB: 15-Sep-89 */
int PASCAL NEAR loffset(LINE *lp);		/* MJB: 25-Sep-89 */
int PASCAL NEAR match_pat(char *patrn);
int PASCAL NEAR mceq(int bc, MC *mt);
int PASCAL NEAR mcscanner(MC *mcpatrn, int direct, int beg_or_end);
int PASCAL NEAR mcstr(void);
int PASCAL NEAR minleftmarg(LINE *lp);		/* MJB: 17-Oct-89 */
int PASCAL NEAR nextch(LINE **pcurline, int *pcuroff, int dir);
int PASCAL NEAR promptpattern(char *prompt);
int PASCAL NEAR pushline(LINE *lp);		/* MJB: 15-Sep-89 */
int PASCAL NEAR readpattern(char *prompt, char *apat, int srch);
int PASCAL NEAR reglines(void);
int PASCAL NEAR remmark(int f, int n);
int PASCAL NEAR replaces(int kind, int f, int n);
int PASCAL NEAR risearch(int f, int n);
int PASCAL NEAR scanmore(char *patrn, int dir);
int PASCAL NEAR scanner(char *patrn, int direct, int beg_or_end);
int PASCAL NEAR setfoldmarks(int f, int n);         /* BG:  11-Oct-89 */
int PASCAL NEAR setlower(char *ch, char *val);
int PASCAL NEAR setupper(char *ch, char *val);
int PASCAL NEAR setvar(int f, int n);
int PASCAL NEAR sindex(char *source, char *pattern);
int PASCAL NEAR stol(char *val);
int PASCAL NEAR svar(VDESC *var, char *value);
int PASCAL NEAR tgetc(void);
int PASCAL NEAR tindx(char *s, char *t, int l);		/* MJB: 26-Sep-89 */
int PASCAL NEAR uneat(void);
LINE *PASCAL NEAR lalloc( int used);
LINE *PASCAL NEAR lback( LINE *lp);		/* MJB: 14-Sep-89 */
LINE *PASCAL NEAR lforw( LINE *lp);		/* MJB: 14-Sep-89 */
LINE *PASCAL NEAR mouseline( WINDOW *wp,  int row);
LINE *PASCAL NEAR popline(void);		/* MJB: 15-Sep-89 */
INT PASCAL NEAR addline(char *text);
INT PASCAL NEAR adjustmode(int kind, int global);
INT PASCAL NEAR anycb(void);
INT PASCAL NEAR apro(int f, int n);
INT PASCAL NEAR asc_int(char *st);
INT PASCAL NEAR backchar(int f,  int n);
INT PASCAL NEAR backdel(int f, int n);
INT PASCAL NEAR backhunt(int f, int n);
INT PASCAL NEAR backline(int f, int n, int raw);
INT PASCAL NEAR backpage( int f,  int n);
INT PASCAL NEAR backsearch(int f, int n);
INT PASCAL NEAR backword(int f, int n);
INT PASCAL NEAR bbackline(int f, int n);		/* MJB: 13-Oct-89 */
INT PASCAL NEAR bclear( BUFFER *bp);
INT PASCAL NEAR bforwline(int f, int n);		/* MJB: 13-Oct-89 */
INT PASCAL NEAR bindtokey(int f, int n);
INT PASCAL NEAR bktoshell();
INT PASCAL NEAR buildlist(int type, char *mstring);
INT PASCAL NEAR capword(int f, int n);
INT PASCAL NEAR cbuf(int f, int n, int bufnum);
INT PASCAL NEAR cbuf1(int f, int n);
INT PASCAL NEAR cbuf10(int f, int n);
INT PASCAL NEAR cbuf11(int f, int n);
INT PASCAL NEAR cbuf12(int f, int n);
INT PASCAL NEAR cbuf13(int f, int n);
INT PASCAL NEAR cbuf14(int f, int n);
INT PASCAL NEAR cbuf15(int f, int n);
INT PASCAL NEAR cbuf16(int f, int n);
INT PASCAL NEAR cbuf17(int f, int n);
INT PASCAL NEAR cbuf18(int f, int n);
INT PASCAL NEAR cbuf19(int f, int n);
INT PASCAL NEAR cbuf2(int f, int n);
INT PASCAL NEAR cbuf20(int f, int n);
INT PASCAL NEAR cbuf21(int f, int n);
INT PASCAL NEAR cbuf22(int f, int n);
INT PASCAL NEAR cbuf23(int f, int n);
INT PASCAL NEAR cbuf24(int f, int n);
INT PASCAL NEAR cbuf25(int f, int n);
INT PASCAL NEAR cbuf26(int f, int n);
INT PASCAL NEAR cbuf27(int f, int n);
INT PASCAL NEAR cbuf28(int f, int n);
INT PASCAL NEAR cbuf29(int f, int n);
INT PASCAL NEAR cbuf3(int f, int n);
INT PASCAL NEAR cbuf30(int f, int n);
INT PASCAL NEAR cbuf31(int f, int n);
INT PASCAL NEAR cbuf32(int f, int n);
INT PASCAL NEAR cbuf33(int f, int n);
INT PASCAL NEAR cbuf34(int f, int n);
INT PASCAL NEAR cbuf35(int f, int n);
INT PASCAL NEAR cbuf36(int f, int n);
INT PASCAL NEAR cbuf37(int f, int n);
INT PASCAL NEAR cbuf38(int f, int n);
INT PASCAL NEAR cbuf39(int f, int n);
INT PASCAL NEAR cbuf4(int f, int n);
INT PASCAL NEAR cbuf40(int f, int n);
INT PASCAL NEAR cbuf5(int f, int n);
INT PASCAL NEAR cbuf6(int f, int n);
INT PASCAL NEAR cbuf7(int f, int n);
INT PASCAL NEAR cbuf8(int f, int n);
INT PASCAL NEAR cbuf9(int f, int n);
INT PASCAL NEAR cex(int f, int n);
INT PASCAL NEAR cinsert(void);
INT PASCAL NEAR clean();
INT PASCAL NEAR closefold(int f, int n);	/* MJB: 11-Sep-89 */
INT PASCAL NEAR clrmes(int f, int n);
void PASCAL NEAR cmdstr(int c, char *seq);
INT PASCAL NEAR copyregion(int f, int n);
void PASCAL NEAR crypt( char *bptr,  unsigned int len);
INT PASCAL NEAR ctlxe(int f, int n);
INT PASCAL NEAR ctlxlp(int f, int n);
INT PASCAL NEAR ctlxrp(int f, int n);
INT PASCAL NEAR ctoec(int c);
INT PASCAL NEAR ctrlg(int f, int n);
INT PASCAL NEAR dcline(int argc, char **argv);
INT PASCAL NEAR deblank(int f, int n);
INT PASCAL NEAR debug(BUFFER *bp, char *eline);
INT PASCAL NEAR delbword(int f, int n);
INT PASCAL NEAR delfold(int f, int n);		/* MJB: 21-Sep-89 */
INT PASCAL NEAR delfword(int f, int n);
INT PASCAL NEAR delgmode(int f, int n);
INT PASCAL NEAR delins(int dlength, char *instr, int use_meta);
INT PASCAL NEAR delmode(int f, int n);
INT PASCAL NEAR delwind(int f, int n);
INT PASCAL NEAR desbind(int f, int n);
void PASCAL NEAR deskey(int f, int n);
INT PASCAL NEAR detab(int f, int n);
INT PASCAL NEAR dobuf(BUFFER *bp);
INT PASCAL NEAR docmd(char *cline);
INT PASCAL NEAR dofile(char *fname);
INT PASCAL NEAR ectoc(int c);
INT PASCAL NEAR edinit(char *bname);
INT PASCAL NEAR editloop(void);
INT PASCAL NEAR endword(int f, int n);
INT PASCAL NEAR enlargewind(int f, int n);
INT PASCAL NEAR entab(int f, int n);
INT PASCAL NEAR enterfold(int f, int n);	/* MJB: 11-Sep-89 */
INT PASCAL NEAR execbuf(int f, int n);
INT PASCAL NEAR execcmd(int f, int n);
INT PASCAL NEAR execfile(int f, int n);
INT PASCAL NEAR execprg();
INT PASCAL NEAR execproc(int f, int n);
INT PASCAL NEAR execprog();
INT PASCAL NEAR execute(int c, int f, int n);
INT PASCAL NEAR exitallfolds(int f, int n);	/* MJB: 21-Sep-89 */
INT PASCAL NEAR exitfold(int f, int n);		/* MJB: 11-Sep-89 */
INT PASCAL NEAR expandp(char *srcstr, char *deststr, int maxlength);
INT PASCAL NEAR ffclose(void);
INT PASCAL NEAR ffgetline(void);
INT PASCAL NEAR ffputline(char *buf, int nbuf);
INT PASCAL NEAR ffropen(const char *fn);
INT PASCAL NEAR ffwopen(char *fn);
INT PASCAL NEAR filefind(int f, int n);
INT PASCAL NEAR filename(int f, int n);
INT PASCAL NEAR fileread(int f, int n);
INT PASCAL NEAR filesave(int f, int n);
INT PASCAL NEAR filewrite(int f, int n);
INT PASCAL NEAR fillpara(int f, int n);
INT PASCAL NEAR filter();
void PASCAL NEAR findvar(char *var, VDESC *vd, int size);
INT PASCAL NEAR fmatch(char ch);
INT PASCAL NEAR fnclabel();
INT PASCAL NEAR forwchar(int f,  int n);
INT PASCAL NEAR forwdel(int f, int n);
INT PASCAL NEAR forwhunt(int f, int n);
INT PASCAL NEAR forwline(int f, int n, int raw);
INT PASCAL NEAR forwpage(int f,  int n);
INT PASCAL NEAR forwsearch(int f, int n);
INT PASCAL NEAR forwword(int f, int n);
void PASCAL NEAR freewhile(WHBLOCK *wp);
INT PASCAL NEAR getccol(int bflg);
INT PASCAL NEAR getcline(void);
INT PASCAL NEAR getcmd(void);
INT PASCAL NEAR getfence(int f, int n);
INT PASCAL NEAR getfile(char *fname, int lockfl);
FOLDMARKENT *PASCAL NEAR getftype(char *fname);	/* BG:  11-Oct-89 */
INT PASCAL NEAR getgoal( LINE *dlp);
INT PASCAL NEAR getrawregion( REGION *rp);	/* MJB: 26-Sep-89 */
INT PASCAL NEAR getregion( REGION *rp);
INT PASCAL NEAR getstring(char *prompt, char *buf, int nbuf, int eolchar);
INT PASCAL NEAR gotobob(int f, int n);
INT PASCAL NEAR gotobol(int f, int n);
INT PASCAL NEAR gotobop(int f, int n);
INT PASCAL NEAR gotoeob(int f, int n);
INT PASCAL NEAR gotoeol(int f, int n);
INT PASCAL NEAR gotoeop(int f, int n);
INT PASCAL NEAR gotoline(int f, int n);
INT PASCAL NEAR gotomark(int f, int n);
INT PASCAL NEAR help(int f, int n);
INT PASCAL NEAR ifile(char *fname);
INT PASCAL NEAR indent(int f, int n);
void PASCAL NEAR initchars(void);
INT PASCAL NEAR initfoldstrings(void);
INT PASCAL NEAR insbrace(int n, int c);
INT PASCAL NEAR insfile(int f, int n);
INT PASCAL NEAR inspound(void);
INT PASCAL NEAR insspace(int f, int n);
INT PASCAL NEAR inword(void);
INT PASCAL NEAR isearch(int f, int n);
INT PASCAL NEAR ismodeline(WINDOW *wp, int row);
INT PASCAL NEAR istring(int f, int n);
INT PASCAL NEAR kdelete(void);
INT PASCAL NEAR killbuffer(int f, int n);
INT PASCAL NEAR killpara(int f, int n);
INT PASCAL NEAR killregion(int f, int n);
INT PASCAL NEAR killtext(int f, int n);
INT PASCAL NEAR kinsert(char c);
INT PASCAL NEAR lchange( int flag);
INT PASCAL NEAR ldelete(long int n, int kflag, int rawmode, int margmode);
INT PASCAL NEAR ldelnewline(int rawmode);
INT PASCAL NEAR lfree( LINE *lp);
INT PASCAL NEAR linsert(int n, char c, int margmode);
INT PASCAL NEAR linstr(char *instr);
INT PASCAL NEAR listbuffers(int f, int n);
INT PASCAL NEAR lnewline(void);
void PASCAL NEAR long_asc(char *buf, int width, long int num);
INT PASCAL NEAR lover(char *ostr);
INT PASCAL NEAR lowerregion(int f, int n);
INT PASCAL NEAR lowerword(int f, int n);
INT PASCAL NEAR lowrite(char c);
INT PASCAL NEAR macarg(char *tok);
INT PASCAL NEAR macrotokey(int f, int n);
INT PASCAL NEAR makefold(int f, int n);		/* MJB: 11-Sep-89 */
INT PASCAL NEAR makelist(int iflag);
void PASCAL NEAR makelit(char *s);
INT PASCAL NEAR mcclear(void);
INT PASCAL NEAR meexit(int status);
INT PASCAL NEAR meta(int f, int n);
void PASCAL NEAR mlerase(void);
void PASCAL NEAR mlforce(char *s);
void PASCAL NEAR mlout(int c);
void PASCAL NEAR mlputf(int s);
void PASCAL NEAR mlputi(int i, int r);
void PASCAL NEAR mlputli(long int l, int r);
void PASCAL NEAR mlputs(char *s);
INT PASCAL NEAR mlreply(char *prompt, char *buf, int nbuf);
INT PASCAL NEAR mltreply(char *prompt, char *buf, int nbuf, int eolchar);
INT PASCAL NEAR mlyesno(char *prompt);
void PASCAL NEAR modeline(WINDOW *wp);
INT PASCAL NEAR mouseoffset( WINDOW *wp,
                         LINE *lp,
                         int col);
void PASCAL NEAR movecursor(int row, int col);
INT PASCAL NEAR movemd(int f, int n);
INT PASCAL NEAR movemu(int f, int n);
INT PASCAL NEAR mregdown(int f, int n);
INT PASCAL NEAR mregup(int f, int n);
INT PASCAL NEAR mvdnwind(int f, int n);
INT PASCAL NEAR mvupwind(int f, int n);
INT PASCAL NEAR namebuffer(int f, int n);
INT PASCAL NEAR namedcmd(int f, int n);
INT PASCAL NEAR narrow(int f, int n);
INT PASCAL NEAR newline(int f, int n);
INT PASCAL NEAR newsize(int f, int n);
INT PASCAL NEAR newwidth(int f, int n);
INT PASCAL NEAR nextarg(char *prompt, char *buffer, int size, int terminator);
INT PASCAL NEAR nextbuffer(int f, int n);
INT PASCAL NEAR nextdown(int f, int n);
INT PASCAL NEAR nextup(int f, int n);
INT PASCAL NEAR nextwind(int f, int n);
INT PASCAL NEAR nullproc(int f, int n);
INT PASCAL NEAR onlywind(int f, int n);
INT PASCAL NEAR openfold(int f, int n);		/* MJB: 11-Sep-89 */
INT PASCAL NEAR openline(int f, int n);
INT PASCAL NEAR openoutfolds(void);	/* MJB: 13-Oct-89 */
INT PASCAL NEAR ostring(char *s);
INT PASCAL NEAR outstring(char *s);
INT PASCAL NEAR ovstring(int f, int n);
INT PASCAL NEAR pipecmd();
INT PASCAL NEAR prevwind(int f, int n);
INT PASCAL NEAR putctext(char *iline);
INT PASCAL NEAR putline();
INT PASCAL NEAR qreplace(int f, int n);
INT PASCAL NEAR quickexit(int f, int n);
INT PASCAL NEAR quit(int f, int n);
INT PASCAL NEAR quote(int f, int n);
INT PASCAL NEAR rdonly(void);
INT PASCAL NEAR readin(char *fname, int lockfl);
INT PASCAL NEAR reform(char *para);
INT PASCAL NEAR reframe(WINDOW *wp);
INT PASCAL NEAR refresh(int f, int n);
INT PASCAL NEAR removefold(int f, int n);	/* MJB: 11-Sep-89 */
INT PASCAL NEAR reposition(int f, int n);
INT PASCAL NEAR resetkey(void);
INT PASCAL NEAR resize(int f, int n);
INT PASCAL NEAR resizm(int f, int n);
INT PASCAL NEAR resterr(void);
INT PASCAL NEAR restwnd(int f, int n);
INT PASCAL NEAR rmcclear(void);
INT PASCAL NEAR rmcstr(void);
INT PASCAL NEAR rvstrcpy( char *rvstr,  char *str);
INT PASCAL NEAR savematch(void);
INT PASCAL NEAR savewnd(int f, int n);
INT PASCAL NEAR scwrite();
INT PASCAL NEAR searchffold(int f, int n);	/* MJB: 21-Sep-89 */
INT PASCAL NEAR searchbfold(int f, int n);	/* MJB: 21-Sep-89 */
INT PASCAL NEAR setbit(int bc, BITMAP cclmap);
INT PASCAL NEAR setccol(int pos);
INT PASCAL NEAR setekey(int f, int n);
INT PASCAL NEAR setfillcol(int f, int n);
INT PASCAL NEAR setgmode(int f, int n);
INT PASCAL NEAR setjtable(char *apat);
INT PASCAL NEAR setmark(int f, int n);
INT PASCAL NEAR setmod(int f, int n);
INT PASCAL NEAR shellprog();
INT PASCAL NEAR showcpos(int f, int n);
INT PASCAL NEAR shrinkwind(int f, int n);
INT PASCAL NEAR spal();
INT PASCAL NEAR spawn();
INT PASCAL NEAR spawncli();
INT PASCAL NEAR splitwind(int f, int n);
INT PASCAL NEAR sreplace(int f, int n);
INT PASCAL NEAR startup(char *sfname);
INT PASCAL NEAR storemac(int f, int n);
INT PASCAL NEAR storeproc(int f, int n);
INT PASCAL NEAR strinc(char *source, char *sub);
INT PASCAL NEAR swapmark(int f, int n);
INT PASCAL NEAR swbuffer(BUFFER *bp);
INT PASCAL NEAR tab(int f, int n);
INT PASCAL NEAR trim(int f, int n);
INT PASCAL NEAR ttclose();
INT PASCAL NEAR ttflush();
INT PASCAL NEAR ttgetc();
INT PASCAL NEAR ttopen();
INT PASCAL NEAR ttputc();
INT PASCAL NEAR twiddle(int f, int n);
INT PASCAL NEAR typahead();
INT PASCAL NEAR unarg(void);
INT PASCAL NEAR unbindchar(int c);
INT PASCAL NEAR unbindkey(int f, int n);
INT PASCAL NEAR unmark(int f, int n);
INT PASCAL NEAR unqname(char *name);
void PASCAL NEAR updall(WINDOW *wp);
INT PASCAL NEAR update(int force);
void PASCAL NEAR upddex(void);
void PASCAL NEAR updext(void);
void PASCAL NEAR updgar(void);
void PASCAL NEAR updone(WINDOW *wp);
void PASCAL NEAR updpos(void);
INT PASCAL NEAR updupd(int force);
void PASCAL NEAR upmode(void);
INT PASCAL NEAR upperregion(int f, int n);
INT PASCAL NEAR upperword(int f, int n);
INT PASCAL NEAR upscreen(int f, int n);
void PASCAL NEAR upwind(void);
INT PASCAL NEAR usebuffer(int f, int n);
void PASCAL NEAR varclean(void);
void PASCAL NEAR varinit(void);
INT PASCAL NEAR viewfile(int f, int n);
void PASCAL NEAR vteeol(void);
INT PASCAL NEAR vtfree();
void PASCAL NEAR vtinit(void);
void PASCAL NEAR vtmove(int row, int col);
void PASCAL NEAR vtputc(int c);
void PASCAL NEAR vttidy(void);
INT PASCAL NEAR widen(int f, int n);
INT PASCAL NEAR wordcount(int f, int n);
INT PASCAL NEAR wrapword(int f, int n);
INT PASCAL NEAR writemsg(int f, int n);
INT PASCAL NEAR writeout(char *fn);
INT PASCAL NEAR yank(int f, int n);
INT PASCAL NEAR zotbuf( BUFFER *bp);
unsigned int PASCAL NEAR chcase( unsigned int ch);
unsigned int PASCAL NEAR getckey(int mflag);
unsigned int PASCAL NEAR stock(char *keyname);
KEYTAB *getbind(int c);
WINDOW *PASCAL NEAR mousewindow( int row);
WINDOW *PASCAL NEAR wpopup(void);

#if	MSDOS & TURBO
INT PASCAL NEAR binary(char *, char *(PASCAL NEAR *)(), int);
#else
INT PASCAL NEAR binary(char *key, char *(*tval) (),  int tlength);
#endif

#if	COMPLET
char *PASCAL NEAR getffile();
char *PASCAL NEAR getnfile();
#endif

char PASCAL NEAR upperc(char ch);
char PASCAL NEAR lowerc(char ch);

#if	DIACRIT
int PASCAL NEAR islower();
int PASCAL NEAR isupper();
int PASCAL NEAR isletter(unsigned int ch);
#endif

#if	MAGIC
BITMAP PASCAL NEAR clearbits(void);
#endif

#if	DTL
void CDECL NEAR mlwrite(...);
#else
void CDECL NEAR mlwrite(char *, ...);
#endif

void uppercase(char *cp);

/* some library redefinitions */


